<?php
/*
Plugin Name: Ultimate Tweaker
Plugin URI: https://ultimate-tweaker.com/
Description:
Version: 2.4.5
Text Domain: ultimate-tweaker
Author: پرشین اسکریپت
Author URI: https://www.persianscript.ir
License: http://amino-studio.com/license/
*/

if (!defined('ABSPATH')) {
    die('-1');
}


define('UT_NAME', 'Ultimate Tweaker');
define('UT_VERSION', '2.4.5');
define('UT_SLUG', 'ultimate-tweaker');

if (!class_exists('ultimate_tweaker_Plugin_File')) {
    class ultimate_tweaker_Plugin_File {
        /** @var UT_Core_Helper  */
        public $helper;

        /**
         * @return UT_Core_Helper
         */
        public function getHelper() {
            return $this->helper;
        }

        /**
         * @return UT_Settings
         */
        public function getSettings() {
            return $this->settings;
        }

        private $settings;

        function __construct() {
            require_once(plugin_dir_path(__FILE__) . 'includes/core/helper.php');

            $this->helper = new UT_Core_Helper(__FILE__,
                UT_NAME,
                UT_SLUG,
                UT_VERSION,
                (defined('WP_DEBUG') && WP_DEBUG == true));

            if(!$this->helper->isSupported()) return;

//            
//            

            $this->helper->requireOnce('only-tweaker/only-tweaker.php');
            $this->helper->requireOnce('admin-menu-tweaker/admin-menu-tweaker.php');

            if (is_admin()) {
                if($this->helper->isPluginActive('only-tweaker')) {
                    $this->helper->deactivatePlugin( 'only-tweaker' );
                }
                if($this->helper->isPluginActive('admin-menu-tweaker')) {
                    $this->helper->deactivatePlugin( 'admin-menu-tweaker' );
                }

                add_action('admin_menu', array($this, 'addMenu'), 10);
                add_action('network_admin_menu', array($this, 'addMenu'), 10);
            }
        }

        function addMenu() {
            add_menu_page(
                $this->helper->getName(),
                $this->helper->getName(),
                'manage_options',
                'only-tweaker',
                null,
//                function() { echo '<script> window.location="'.admin_url('/admin.php?page=only-tweaker').'"; </script> '; exit; },
                $this->helper->pluginUrl('assets/admin-icon.png'),
                null);
        }
    }
}

new ultimate_tweaker_Plugin_File();
